module mod_common_var

	use mod_types

	implicit none
		
	!----------------------------------------------------------------
	! 1. Calibration
	!----------------------------------------------------------------

	real (dp), parameter :: delta  = 0.0196 					! Depreciation
	real (dp), parameter :: alpha  = 0.4							! Capital Share 
	real (dp), parameter :: tau    = 2.d0							! risk aversion
	real (dp), parameter :: beta	 = 0.9896 		      ! Discount factor
	real (dp), parameter :: theta  = 0.357						! Weight on consumptiomn
	real (dp), parameter :: rho    = 0.95							! Autoregressive 
	real (dp), parameter :: sigma  = 0.007						! Variance

	!----------------------------------------------------------------
	! 2. Numerical parameters
	!---------------------------------------------------------------- 

	integer :: n_tauchen = 40													! Number Tauchen points 
	integer :: multigrid_steps = 5									

	real (dp), parameter :: toler   = 1e-8						! Numerical tolerance
	real (dp), parameter :: epsilon = 1e-3						! Step for Numerical Derivative
	real (dp) :: step
	
	!----------------------------------------------------------------
	! 3. Policy Functions
	!---------------------------------------------------------------- 

	real(dp), allocatable, dimension(:,:)  :: g_l, g_k

end module mod_common_var