subroutine sub_accelerator(value,grid_k,length_grid_k,y,transition)
	
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k
	integer :: index_k, index_z

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: value
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	real(dp), dimension(length_grid_k,n_tauchen) :: value_prov
	real(dp), dimension(n_tauchen) :: value_interp
	real(dp) :: diff, k, kp, z, l, c 

	do i1 = 1,30	

		do index_k = 1, length_grid_k				! Capital grid
			
			k = grid_k(index_k)
			
			do index_z = 1, n_tauchen
				
				z = y(index_z)
				
				kp = g_k(index_k,index_z)
				l = g_l(index_k,index_z)
				c = exp(z)*(k**alpha)*(l**(1-alpha))+(1-delta)*k-kp
				if (c<0.0) then
					c = 0.00000001
				endif
				
					
				do i2 = 1, n_tauchen
					call sub_myinterp(grid_k,value(:,i2),kp,size(grid_k),value_interp(i2))
				enddo
					
				value_prov(index_k,index_z) = (1-beta)*(((c**theta)*((1-l)**(1-theta)))**(1-tau))/(1-tau)+&
																			&beta*dot_product(transition(index_z,:),value_interp(:))  

				enddo

			enddo
			
			diff  = maxval(abs(value_prov-value))/maxval(abs(value))
			
			if (length_grid_k>100) then
				write(*, '(a11, i4, a18, f16.13)'), 'Acelerator =',i1,'with sup_norm =',diff	
			endif	
			
			value = value_prov 

			if (diff<toler .and. i1>5) then
				exit
			endif

		enddo			
  					 
end subroutine sub_accelerator