subroutine sub_myinterp_shape(x,f_x,length_index,xp,deriv,interp_value)

	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_index

	real (dp), dimension(length_index), intent(in) :: x
	real (dp), dimension(length_index), intent(in) :: f_x
	real (dp), dimension(length_index), intent(in) :: deriv
	real (dp), intent(in) :: xp
	real (dp), intent(out) :: interp_value
	
	real (dp) :: delta_judd
	real (dp) :: alpha_xi, beta_xi, a1, a2, b1, b2, c1, c2, s_upper, xi, xi_upper, xi_lower
	real (dp) :: check1, check2, check3

	if (xp>x(2) .and. length_index == 3) then
		
		delta_judd = (f_x(3)-f_x(2))/(x(3)-x(2))
		
		check1 = (deriv(2)-delta_judd)*(deriv(3)-delta_judd)
		check2 = abs(deriv(3)-delta_judd) 
		check3 = abs(deriv(2)-delta_judd)
		
		if (check1 .ge. 0.d0) then
			xi = 0.5d0*(x(3)+x(2))
		elseif (check2 .lt. check3) then
				xi_upper = x(2)+2.d0*(x(3)-x(2))*(deriv(3)-delta_judd)/(deriv(3)-deriv(2))
				xi = 0.5d0*(x(2)+xi_upper)
				else
					xi_lower = x(3)+2.d0*(x(3)-x(2))*(deriv(2)-delta_judd)/(deriv(3)-deriv(2))
					xi = 0.5d0*(x(3)+xi_lower)
		endif
		
		alpha_xi = xi-x(2)
		beta_xi  = x(3)-xi
		s_upper = (2.d0*(f_x(3)-f_x(2))-(alpha_xi*deriv(2)+beta_xi*deriv(3)))/(x(3)-x(2))
		a1 = f_x(2)
		b1 = deriv(2)
		c1 = (s_upper-deriv(2))/(2*alpha_xi)

		if(xp<xi) then	
			interp_value = a1+b1*(xp-x(2))+c1*((xp-x(2))**2)
		else
			a2 = a1+alpha_xi*b1+alpha_xi**2*c1
			b2 = s_upper
			c2 = (deriv(3)-s_upper)/(2*beta_xi)
			interp_value = a2+b2*(xp-xi)+c2*((xp-xi)**2)
		endif
	
	else

		delta_judd = (f_x(2)-f_x(1))/(x(2)-x(1))
		
		check1 = (deriv(1)-delta_judd)*(deriv(2)-delta_judd)
		check2 = abs(deriv(2)-delta_judd) 
		check3 = abs(deriv(1)-delta_judd)
		
		if (check1 .ge. 0.d0) then
			xi = 0.5d0*(x(2)+x(1))
		elseif (check2 .lt. check3) then
				xi_upper = x(1)+2.d0*(x(2)-x(1))*(deriv(2)-delta_judd)/(deriv(2)-deriv(1))
				xi = 0.5d0*(x(1)+xi_upper)
				else
					xi_lower = x(2)+2.d0*(x(2)-x(1))*(deriv(1)-delta_judd)/(deriv(2)-deriv(1))
					xi = 0.5d0*(x(2)+xi_lower)
		endif
		
		alpha_xi = xi-x(1)
		beta_xi  = x(2)-xi
		s_upper = (2.d0*(f_x(2)-f_x(1))-(alpha_xi*deriv(1)+beta_xi*deriv(2)))/(x(2)-x(1))
		a1 = f_x(1)
		b1 = deriv(1)
		c1 = (s_upper-deriv(1))/(2*alpha_xi)

		if(xp<xi) then	
			interp_value = a1+b1*(xp-x(1))+c1*((xp-x(1))**2)
		else
			a2 = a1+alpha_xi*b1+alpha_xi**2*c1
			b2 = s_upper
			c2 = (deriv(2)-s_upper)/(2*beta_xi)
			interp_value = a2+b2*(xp-xi)+c2*((xp-xi)**2)
		endif
	
	endif

end subroutine sub_myinterp_shape