subroutine sub_tauchen(y,pi,rho,sigma,n,cover_tauchen)

	use msimsl
	use mod_types

	implicit none

	integer, intent(in) :: n
	
	real(dp), intent(in) :: rho, sigma, cover_tauchen
	real(dp), dimension (n,n), intent(out) :: pi
	real(dp), dimension (n), intent(out) :: y
		
	integer :: yc, tc, tcc
	
	real(dp) :: sigy, mu, upp, low
	
	! Define the discrete states of the Markov chain
	
	sigy = sigma/sqrt(1.0-rho**2)
	
	y(n) = cover_tauchen*sigy !%(sqrt(n)/sqrt(2.0))*sigy ! good for 0.007, increase later
	y(1) = -y(n)
	
	do yc = 2, n-1
		
		y(yc) = y(1)+(y(n)-y(1))*(yc-1.0)/(n-1.0)
	
	end do
	
	! Compute the transition matrix
	
	do tc = 1,n
		
		mu = rho*y(tc)
		upp = (y(2)+y(1))/2.0
		upp = (upp-mu)/sigma
		pi(tc,1) = DNORDF(upp)
		low = (y(n)+y(n-1))/2.0
		low = (low-mu)/sigma
		pi(tc,n) = 1.0-DNORDF(low)
		
		do tcc = 2, n-1		
			
			low = (y(tcc-1)+y(tcc))/2.0
			upp = (y(tcc+1)+y(tcc))/2.0
			low = (low-mu)/sigma
			upp = (upp-mu)/sigma
			pi(tc,tcc) = DNORDF(upp)-DNORDF(low)
		
		end do
	
	end do

	open(unit=98,file='Tauchen.txt')
	write(98,*) 'rho, sigma, n'
	write(98,*) rho, sigma, n
	write(98,*) 'Income States'
	write(98,*) y(1:n)
	write(98,*) 'Transition Matrix'
	
	do tc=1,n
		write(98,*) pi(tc,:)
	end do
	
	close(98)
	
end subroutine sub_tauchen