subroutine sub_value(value,grid_k,length_grid_k,y,transition,max_iterations,print_mod)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k, max_iterations, print_mod

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: value
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	
	integer :: iter, go_on, index_k, index_kp, index_z, previous_kp, index_maxk_so_far, flag

	real(dp), dimension(length_grid_k,n_tauchen) :: value_prov, g_lprov, g_kprov
	real(dp) :: diff, diff2, k, kp, z, mylabor, c, value_max_so_far, value_comp, value_refinement, l, mylaborold, mylabornew

	iter = 1
  diff = 1000.d0
   
  value_prov = 0.d0
  g_l = 0.d0
  g_lprov = 0.d0
  g_k = 0.d0
  g_kprov = 0.d0

	go_on = 1		
	do while (go_on == 1)

		iter = iter+1

		do index_k = 1, length_grid_k				! Capital grid
			
			k = grid_k(index_k)

			do index_z = 1, n_tauchen
				
				if (index_z == 1) then
					previous_kp = 1
				else
					previous_kp = index_maxk_so_far
				endif

				z = y(index_z)
				value_max_so_far = -100000000.d0
				
				flag = 1
				do index_kp = previous_kp, length_grid_k	
					
					kp = grid_k(index_kp)
					
					call sub_newton(kp,k,z,mylabor)

					mylaborold = mylabor

					c = exp(z)*(k**alpha)*(mylabor**(1-alpha))+(1-delta)*k-kp

					if (c>0) then
            
						value_comp = (1-beta)*(((c**theta)*((1-mylabor)**(1-theta)))**(1-tau))/(1-tau)+beta*dot_product(transition(index_z,:),value(index_kp,:))  

            if (value_comp>value_max_so_far) then							
							
							value_max_so_far = value_comp
              g_lprov(index_k,index_z) = mylabor
              g_kprov(index_k,index_z) = kp
							index_maxk_so_far = index_kp
            
						else
							
							if (flag == 1 .and. iter>2 .and. length_grid_k>20) then
								
								if(iter <0) then
									! linear
									call sub_refinement(index_kp,index_z,k,z,grid_k,length_grid_k,transition,value,kp,mylabor,value_refinement)	
								else
									! schumaker
									call sub_refinement1(index_kp,index_z,k,z,y,grid_k,length_grid_k,transition,value,kp,mylabor,value_refinement)
								endif
								
								flag = flag+1	
							
								if (value_max_so_far<value_refinement) then
									value_max_so_far = value_refinement
									g_lprov(index_k,index_z) = mylabor					
									g_kprov(index_k,index_z) = kp
								endif
							
						  endif

						endif
          else
						exit
          endif

				enddo

				value_prov(index_k,index_z) = value_max_so_far

			enddo

		enddo

		diff  = maxval(abs(value_prov-value))/maxval(abs(value))
		diff2 = maxval(abs(g_lprov-g_l))
    value = value_prov
    
    g_l = g_lprov
    g_k = g_kprov

		if (iter==2 .or. mod(iter-1,print_mod)==0) then
			write(*, '(a11, i4, a18, f16.13, a17, f16.13)'), 'Iteration =',iter-1,'with sup_norm =',diff,'and labor change',diff2 
		endif
		
		if (iter>max_iterations .or. diff<toler) then
			go_on = 0
		else
			
			! Accelerator

			if (length_grid_k>200) then
				call sub_accelerator(value,grid_k,length_grid_k,y,transition)
			endif
		endif

	enddo

	print *, ' '
  print *, 'Successfully converged with sup_norm ', diff

end subroutine sub_value